import java.lang.*;

interface AbstractInterface {
	double Function(double x);
	double Integrate();
};

abstract class AbstractIntegrator implements AbstractInterface {
	int n;
	double a, b;
	public double Integrate()
	{
		double s = 0;
		double last_f = Math.abs(Function(a)), cur_f;
		double h = (b - a) / n;
		double pos = a + h;

		for (int i = 1; i < n; i++, pos += h)
		{
			cur_f = Math.abs(Function(pos));
			s += cur_f * h + (last_f - cur_f) * h / 2;
			last_f = cur_f;
		}

		return s;
	}
	public AbstractIntegrator(double ai, double bi, int ni)
	{ 
		if (a > b)
		{
			a = bi;
			b = ai;
		}
		else
		{
			a = ai; 
			b = bi;
		}
		n = ni;
	}
}

class Integrator extends AbstractIntegrator {
	public double Function(double x)
	{
		return Math.tan(Math.sqrt(6 * x));
	}
	public Integrator(double ai, double bi, int ni)
	{
		super(ai, bi, ni);
	}
};

class Integral {
	public static void main(String args[])
	{
		double A = 0;
		double B = Math.PI / 8;
		int N = 100;

		Integrator MyIntegrator = new Integrator(A, B, N);
		System.out.println("Integrating result: " + MyIntegrator.Integrate());
		System.out.println("Integrated function: tan(sqrt(6 * x))");
		System.out.print("Integrating range: ");
		System.out.println("A = " + A + ", B = " + B);
		System.out.println("Number of pieces: " + N);
	}
}

// 0 - PI * PI / 24
